2010-07-13  Levi Bard  <levi@unity3d.com>

	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs: 
	  Add method for unescaping strings.

2010-05-20  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: Dispose
	  asynchronously.

2010-05-20  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/BaseBacktrace.cs:
	* Mono.Debugging.Evaluation/ExceptionInfoSource.cs: Fix crash
	  when getting locals which include the last thrown exception.

2010-05-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/StackFrame.cs:
	* Mono.Debugging.Backend/IBacktrace.cs:
	* Mono.Debugging.Client/ExceptionInfo.cs:
	* Mono.Debugging.Evaluation/BaseBacktrace.cs:
	* Mono.Debugging.Evaluation/ExceptionInfoSource.cs: Introduced
	  ExceptionInfo, which provides information about a caught
	  exception, including description and stack traces.

	* Mono.Debugging.Client/RawValue.cs:
	* Mono.Debugging.Evaluation/RemoteRawValue.cs:
	* Mono.Debugging.Backend/IObjectValueSource.cs: Added
	  evaluation options to raw value methods.

	* Mono.Debugging.Client/ObjectValue.cs: Connect children
	  directly added to the object value. Propagate eval options
	  to raw value objects.

2010-05-11  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/AsyncOperationManager.cs: Fixed
	  deadlock while shuting down.

2010-05-07  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/StackFrame.cs: Added HasDebugInfo
	  argument. When set to true, the stack frame won't try to get
	  any information from the underlaying frame.

2010-05-07  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Fix
	  support for variable definition. Implement support for
	  pre/post increment/decrement.

2010-05-07  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/StackFrame.cs:
	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Backend/IObjectValueSource.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/NullValueReference.cs:
	* Mono.Debugging.Evaluation/BaseTypeViewSource.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	* Mono.Debugging.Evaluation/LiteralValueReference.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs:
	* Mono.Debugging.Evaluation/NamespaceValueReference.cs: Added
	  an EvaluationOptions argument to all methods in
	  IObjectValueSource. With this change options are not cached
	  anymore in ValueReference objects. This fixes bug #602894
	  and allows MD to change the evaluation options in the middle
	  of a debugging session.

2010-05-06  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/BaseBacktrace.cs: Use async
	  evaluation when getting the This and Execption values.

2010-04-23  Carlo Kok  <ck@remobjects.com>

	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Client/IExpressionEvaluator.cs:
	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	  Allow for custom expression evaluators.
	
	
2010-04-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/RawValue.cs:
	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/RemoteRawValue.cs:
	* Mono.Debugging.Backend/IObjectValueSource.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/BaseTypeViewSource.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Add
	  support for getting raw values of members and variables.

2010-04-13  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Fix bug
	  #595270 - Flags enums in debugger show the zero value.

2010-03-23  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs: Child
	  selector fixes. Fixes bug #588307 - Cannot pin an element of
	  multidimensional array.

2010-03-15  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/AsyncOperationManager.cs: Use
	  corrent constant for infinite waits.

2010-03-03  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/TypeValueReference.cs: Fixed type
	  name formatting issue.

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Fixed
	  parsing of generic type names.

2010-03-03  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/TypeValueReference.cs: Set the
	  correct type name for the type reference.

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Added hack
	  which allows parsing single generic type names (that is,
	  when the expression is a type name).

2010-03-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Add a
	  better default implementation for ForceLoadType.

2010-03-01  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: Fix null ref.

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Type data
	  should not be static.

	* Mono.Debugging.Evaluation/NRefactoryResolverVisitor.cs:
	  Improved resolution of generic types.

2010-03-01  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Add
	  support for indexer with more than one parameter.

2010-02-26  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/EvaluationOptions.cs: Added clone
	  method.

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Fix crash
	  when parsing enums.

	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Evaluation/BaseTypeViewSource.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Reset
	  the child selector for values which are only visual group of
	  members.

2010-02-24  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/StackFrame.cs: Add null check.

2010-02-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/StackFrame.cs:
	* Mono.Debugging.Backend/IBacktrace.cs:
	* Mono.Debugging.Client/TargetEventArgs.cs:
	* Mono.Debugging.Evaluation/BaseBacktrace.cs:
	* Mono.Debugging.Client/EvaluationOptions.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Added
	  method for getting the current exception when a catchpoint
	  is hit or an exception unhandled.

2010-02-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/StackFrame.cs: Fix win32 build.

2010-02-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/StackFrame.cs:
	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Backend/IBacktrace.cs:
	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Evaluation/BaseBacktrace.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Client/EvaluationOptions.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Backend/IObjectValueSource.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/BaseTypeViewSource.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Add
	  support for evaluating expressions. Allow specifying
	  evaluation options when setting a value. Added option for
	  displaying integers using hex format. Added wait handle for
	  waiting for async evaluation completion on ObjectValue.

2010-02-04  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: Added delegate
	  which is called when a tracepoint is hit.

	* Mono.Debugging.Client/ObjectValue.cs: New ChildSelector
	  property.

	* Mono.Debugging.Evaluation/NRefactoryResolverVisitor.cs: Fix
	  nullref.

2010-02-03  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Added the
	  SetBreakEventStatus method, which can be used by subclasses
	  to set a breakpoint as invalid. Added some docs.

2010-02-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/NRefactoryResolverVisitor.cs:
	  Properly resolve type references.

2010-02-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Fix type
	  arg count code.

2010-01-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/StackFrame.cs:
	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Client/EvaluationOptions.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	* Mono.Debugging.Evaluation/NRefactoryResolverVisitor.cs: Add
	  suport for an external type resolver. The first time an
	  expression is evaluated in a context, the debugger tries to
	  resolve the type references using the external resolver, and
	  will use the resolved expression to do the evaluation.

	* Mono.Debugging.Client/SourceLocation.cs: Add column field.

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Added
	  method for forcing the loading of a type.

2010-01-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Generate
	  NotSupported values when getting such exception.

2010-01-20  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* mono.debugging.snk:
	* Mono.Debugging.csproj: Sign and fix deps.

2010-01-20  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Fix
	  potential string parsing issue. Fixes bug #571232 -
	  System.FormatException: Input string was not in a correct
	  format.

2009-12-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: Workaround for
	  possible deadlock.

2009-12-16  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs: Report the
	  correct error for unsupported expressions. Fixes bug
	  #564452.

2009-12-15  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ObjectValue.cs: Forgot assignment in
	  update method.

	* Mono.Debugging.Backend/IObjectValueSource.cs:
	* Mono.Debugging.Evaluation/LiteralValueReference.cs:
	  LiteralExp has been replaced by EvaluationResult.

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Improve
	  formatting of arrays, enums and types.

	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs: Fix
	  formatting of boolean values. LiteralExp has been replaced
	  by EvaluationResult.

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Fix some
	  evaluation issues.

2009-12-11  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Backend/IObjectValueSource.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/BaseTypeViewSource.cs:
	* Mono.Debugging.Evaluation/LiteralValueReference.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Added a
	  new EvaluationResult class to be used to provide expression
	  evaluation values. This result can contain a value and a
	  display value. The display value is shown in the value cell
	  of the watch window, the original value is used when
	  editing.

	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: When
	  setting a value, try converting it to the target type.

	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs: Add
	  support for character escapes.

2009-12-09  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: When a
	  RootHidden member is found, hide everything but that member.

2009-12-09  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerStartInfo.cs: Added properties
	  to support the external console option.

2009-12-03  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Honor
	  DebuggerBrowsableState in private and static member groups.

2009-12-03  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Evaluation/IObjectSource.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/BaseTypeViewSource.cs:
	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Created
	  the IObjectSource interface, which can be used to keep track
	  of the origin of an object. ValueReference objects now have
	  a reference to the IObjectSource that generated them. This
	  source can be used to update back struct instances.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Evaluation/TimedEvaluator.cs: Name threads to
	  make debugging easier.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: If there's an
	  exceptions when running, attaching, or finishing, exit the
	  session, instead of just stopping it.

2009-12-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/EvaluationOptions.cs:
	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: By default,
	  don't group private members for user classes.

2009-12-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/ObjectValueFlags.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Client/EvaluationOptions.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/BaseTypeViewSource.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Added
	  new evaluation options. Grouping non-public and static
	  members is now optional. Added option for grouping members
	  from base classes in a base group. When disabled, show the
	  base class next to the member name when there are several
	  members with the same name.

2009-12-01  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Added
	  several missing type and null checks.

2009-11-30  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Prettify
	  type names.

2009-11-25  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/StackFrame.cs: A frame should be
	  marked external when file name IS empty.

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Improve
	  error handling.

2009-11-24  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Client/StackFrame.cs: Add property for
	  flagging frame as external code.

2009-11-20  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Client/DebuggerSessionOptions.cs: Add setting
	  for user-code-only debugging.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Fix calls
	  to GetTypeDisplayData.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/TimedEvaluator.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/AsyncEvaluationTracker.cs:
	  Properly dispose resources.

2009-11-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Client/ObjectValueFlags.cs:
	* Mono.Debugging.Evaluation/BaseBacktrace.cs:
	* Mono.Debugging.Client/EvaluationOptions.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/TimedEvaluator.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/AsyncEvaluationTracker.cs:
	  Improved async evaluation. If an evaluation is in process,
	  don't even try to create an evaluation context, just queue
	  the request. Added more evaluation options. Added default
	  implementations for some methods (in ObjectValueAdaptor) and
	  classes (BaseBacktrace), factorized from the soft debugger.

2009-11-18  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/Backtrace.cs:
	* Mono.Debugging.Client/StackFrame.cs: Fix some serialization
	  issues.

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Improve
	  error message.

2009-11-18  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/Backtrace.cs: Add support for
	  refreshing object values.

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/StackFrame.cs:
	* Mono.Debugging.Backend/IBacktrace.cs:
	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Client/ObjectValueFlags.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Client/EvaluationOptions.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Backend/IObjectValueSource.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Client/DebuggerSessionOptions.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs:
	* Mono.Debugging.Evaluation/AsyncOperationManager.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs: Add
	  support for refreshing object values. 

2009-11-17  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Client/DebuggerSessionOptions.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs:
	* Mono.Debugging.Evaluation/AsyncOperationManager.cs:
	* Mono.Debugging.Evaluation/AsyncEvaluationTracker.cs: Add an
	  Options argument to the methods that launch the debugger. By
	  default, run debugger operations in a background thread, to
	  avoid locking the main thread. Improve expression evaluation
	  timeout handling. If an evaluation can't be aborted, notify
	  the user and wait until done or stopped.

2009-11-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Client/Backtrace.cs: Fix list
	  ArgumentOutOfRangeException when soft debugger is stopped in
	  unmanaged code. Not completely sure this is the right fix.

2009-10-29  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.csproj: Flush.

2009-10-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: Fix Pocess/Process
	  spelling. Don't lock in IsRunning or MD can deadlock.

2009-10-05  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ThreadInfo.cs:
	* Mono.Debugging.Client/ProcessInfo.cs:
	* Mono.Debugging.Client/DebuggerSession.cs: Use long for
	  thread and process id.

2009-10-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Don't show
	  the static/non-public groups if they don't contain elements.
	  Fixes bug #543782 - Debug tooltip always shows Static
	  members group.

2009-10-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs:
	* Mono.Debugging.Evaluation/NamespaceValueReference.cs:
	  Alphabetically sort members of types. Fixes bug #543780 -
	  Debug tooltip shows members in random order.

2009-10-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ObjectValue.cs: Allow setting the type
	  name.

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Added null
	  check.

2009-09-29  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation\ObjectValueAdaptor.cs: Add missing
	  length check.

2009-09-25  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Some minor
	  fixes.

2009-09-23  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/BreakpointStore.cs: Clear(): Properly
	  duplicate breakpoint list.

2009-09-23  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ObjectValue.cs: Added some debug code.

	* Mono.Debugging.Evaluation/ICollectionAdaptor.cs:
	  CreateElementValue is not used anymore.

	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs: Make
	  serializable some exceptions.

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Added some
	  preventive error checks.

	* Mono.Debugging.Evaluation/ArrayElementGroup.cs: When
	  generating an array item, use NameDisplayString when defined
	  for the type. Fixed upperBound value for multidimensional
	  arrays.

2009-09-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Added
	  missing null check.

2009-09-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Add
	  support for examining nested types.

2009-09-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: Improve error
	  handling. Exceptions can now be intercept using a delegate.

2009-09-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Try to
	  resolve type names using the imported namespaces.

2009-09-17  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/BreakEvent.cs:
	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Client/BreakpointStore.cs: Added support for
	  disabling changes in the breakpoint store. Some debuggers
	  may not support changing breakpoints while the debugger is
	  running.

2009-09-17  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs: Don't crash if a
	  breakpoint can't be removed.

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/DebuggerException.cs: Added exception
	  to be used to report debugger errors to the user.

2009-09-14  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Ignore '?'
	  prefix. We don't use it, but VS does.

2009-09-14  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/EvaluationContext.cs: Added flag
	  for enabling/disabling execution of debugging target code
	  while inspecting expressions.

	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Fix cast
	  expression evaluation.

2009-08-28  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs: Allow
	  calling a method of the class of the current
	  debugging-scope. Fixes bug #525258.

2009-07-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Evaluation/Backtrace.cs: Remove unused file.

2009-07-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/Backtrace.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/ICollectionAdaptor.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/NullValueReference.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs:
	* Mono.Debugging.Evaluation/ArrayValueReference.cs:
	* Mono.Debugging.Evaluation/LiteralValueReference.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs:
	* Mono.Debugging.Evaluation/UserVariableReference.cs:
	* Mono.Debugging.Evaluation/NamespaceValueReference.cs: Get
	  rid of generic classes because they are causing a lot of
	  trouble in mono.

2009-06-23  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs: Workaround
	  to a bug in mono 2.0. That mono version fails to compile an
	  anonymous method in GetExpressionValuesAsync.

2009-06-16  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation\TypeValueReference.cs: Only show
	  static members as children of types.

	* Mono.Debugging.Evaluation\NRefactoryEvaluator.cs: Don't
	  crash if a method evaluation returns 'void'.

	* Mono.Debugging.Evaluation\LiteralValueReference.cs: Properly
	  support literal expressions.

2009-06-15  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj: Added missing reference.

2009-06-15  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Evaluation\NRefactoryEvaluator.cs: Small
	  optimization.

2009-06-12  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Evaluation:
	* Mono.Debugging.Evaluation/Backtrace.cs:
	* Mono.Debugging.Evaluation/RawViewSource.cs:
	* Mono.Debugging.Evaluation/ValueReference.cs:
	* Mono.Debugging.Evaluation/TimedEvaluator.cs:
	* Mono.Debugging.Evaluation/TimeOutException.cs:
	* Mono.Debugging.Evaluation/ArrayElementGroup.cs:
	* Mono.Debugging.Evaluation/EvaluationContext.cs:
	* Mono.Debugging.Evaluation/RemoteFrameObject.cs:
	* Mono.Debugging.Evaluation/TypeValueReference.cs:
	* Mono.Debugging.Evaluation/NullValueReference.cs:
	* Mono.Debugging.Evaluation/ICollectionAdaptor.cs:
	* Mono.Debugging.Evaluation/ObjectValueAdaptor.cs:
	* Mono.Debugging.Evaluation/NRefactoryEvaluator.cs:
	* Mono.Debugging.Evaluation/ArrayValueReference.cs:
	* Mono.Debugging.Evaluation/ExpressionEvaluator.cs:
	* Mono.Debugging.Evaluation/LiteralValueReference.cs:
	* Mono.Debugging.Evaluation/AsyncOperationManager.cs:
	* Mono.Debugging.Evaluation/FilteredMembersSource.cs:
	* Mono.Debugging.Evaluation/UserVariableReference.cs:
	* Mono.Debugging.Evaluation/AsyncEvaluationTracker.cs:
	* Mono.Debugging.Evaluation/NamespaceValueReference.cs: Added
	  an expression evaluator factorized from the Mdb and Win32
	  debugger addins.

2009-06-04  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Backend/IDebuggerSessionFrontend.cs: Added
	  NotifySourceFile(Un)Loaded to IDebuggerSessionFrontend.

2009-05-25  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client\BreakpointStore.cs: Use case
	  insensitive compare for files on windows.

	* Mono.Debugging.Client\DebuggerSession.cs: Fix crash when
	  updating breakpoints.

2009-05-13  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client\DebuggerSession.cs: Protect access to
	  the breakpoints collection. Added method for notifying
	  loading/unloading of files.

2009-04-27  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.csproj:
	* Mono.Debugging.Client/IDebuggerEngine.cs: Moved
	  IDebuggerEngine to MD.Debugger.

2009-03-04  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/IDebuggerEngine.cs: Removed unused
	  CanDebugPlatform and rename CanDebugFile to CanDebugCommand.

2009-02-06  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.mdp:
	* Mono.Debugging.csproj: Migrated to MSBuild file format.

2009-01-26  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.mdp: Flush project format changes.

2009-01-14  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.Debugging.Client/StackFrame.cs: Remove Console.WriteLine noise.

2008-12-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.Debugging.mdp:
	* Mono.Debugging.Client/StackFrame.cs:
	* Mono.Debugging.Backend/IBacktrace.cs:
	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Backend/UpdateCallback.cs:
	* Mono.Debugging.Client/ObjectValueFlags.cs:
	* Mono.Debugging.Backend/IObjectValueUpdater.cs:
	* Mono.Debugging.Backend/IObjectValueUpdateCallback.cs: Added support
	for asynchronus evaluation of expressions, with support for timeouts.

2008-12-04  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/DebuggerSession.cs:
	* Mono.Debugging.Client/IDebuggerEngine.cs:
	* Mono.Debugging.Client/DebuggerFeatures.cs: Improved support for
	checking debugger features.

2008-12-02  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ObjectValue.cs:
	* Mono.Debugging.Client/ObjectValueFlags.cs: Added new kind of value:
	not supported.

	* Makefile.am: Fix to better support parallel building.

2008-10-22  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.Debugging.Client/ThreadInfo.cs: Added null check.

2008-09-12  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.mdp: Updated.

2008-09-03  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/DebuggerFeatures.cs,
	  Mono.Debugging.Client/DebuggerSession.cs,
	  Mono.Debugging.Client/TargetEventArgs.cs, Mono.Debugging.mdp,
	  Makefile.am: When firing the TargetEvent for an Exception, provide
	  the exception object. Added property for getting the debugger
	  capabilities.

2008-08-22  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.addin.xml, Mono.Debugging.mdp,
	  Mono.Debugging.Backend/DebuggerExtensionNode.cs, Makefile.am:
	  Remove Mono.Addins dependency.

2008-08-07  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/BreakpointStore.cs: Fire the change event when
	  a breakpoint is modified.
	* Mono.Debugging.Client/DebuggerSession.cs: Made GetBreakpointHandle
	  protected so it can be used by add-ins.

2008-08-06  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/BreakpointStore.cs,
	  Mono.Debugging.Client/BreakEvent.cs,
	  Mono.Debugging.Client/DebuggerSession.cs, Mono.Debugging.mdp: Add
	  support for live updating of breakpoint's hit count.

2008-08-05  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/ThreadInfo.cs,
	  Mono.Debugging.Client/DebuggerSession.cs: Add location field to
	  ThreadInfo. Reset the cached process list when receiving a target
	  event.

2008-07-25  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/StackFrame.cs,
	  Mono.Debugging.Backend/IBacktrace.cs: Added api for getting all
	  locals of a stack frame.

2008-07-22  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/BreakEvent.cs,
	  Mono.Debugging.Client/Catchpoint.cs,
	  Mono.Debugging.Client/Breakpoint.cs: Added copying methods. Added
	  property which allows stopping on a breakpoint after the given hit
	  count.

2008-07-21  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/ObjectValue.cs: Added some missing null checks.

2008-07-16  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/BreakpointStore.cs,
	  Mono.Debugging.Client/BreakEvent.cs,
	  Mono.Debugging.Client/Catchpoint.cs,
	  Mono.Debugging.Client/Breakpoint.cs, Mono.Debugging.mdp,
	  Makefile.am: Add serialization support to BreakpointStore.

2008-07-16  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/CatchpointEventArgs.cs,
	  Mono.Debugging.Client/BreakpointStore.cs,
	  Mono.Debugging.Client/BreakEvent.cs,
	  Mono.Debugging.Client/DebuggerSession.cs,
	  Mono.Debugging.Client/TargetEventType.cs,
	  Mono.Debugging.Client/Catchpoint.cs,
	  Mono.Debugging.Client/Breakpoint.cs,
	  Mono.Debugging.Client/BreakEventArgs.cs, Mono.Debugging.mdp,
	  Makefile.am: Implemented support for catchpoints.

2008-07-11  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/BreakpointStore.cs,
	  Mono.Debugging.Client/DebuggerSession.cs,
	  Mono.Debugging.Client/Breakpoint.cs,
	  Mono.Debugging.Backend/IDebuggerSessionFrontend.cs: Added api to
	  support custom breakpoint hit actions.

2008-07-09  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/ThreadInfo.cs,
	  Mono.Debugging.Client/DebuggerSession.cs: Provide the process id
	  when setting the active thread.

2008-07-09  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/ObjectValueFlags.cs: Added Type and Namespace.
	* Mono.Debugging.Client/ObjectValue.cs: Properly set the name when
	  creating an error object.

2008-07-09  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/StackFrame.cs,
	  Mono.Debugging.Client/DebuggerSession.cs,
	  Mono.Debugging.Client/CompletionData.cs, Mono.Debugging.mdp,
	  Mono.Debugging.Backend/IBacktrace.cs, Makefile.am: Added support
	  for code completion.

2008-07-07  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/ObjectValueFlags.cs,
	  Mono.Debugging.Client/StackFrame.cs,
	  Mono.Debugging.Client/ObjectValue.cs,
	  Mono.Debugging.Client/ObjectValueKind.cs, Mono.Debugging.mdp,
	  Mono.Debugging.Backend/IBacktrace.cs, Makefile.am: Added flags enum
	  to ObjectValue which give information about the origin of the
	  value.

2008-07-02  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/ObjectPath.cs: Implemented ToString.
	* Mono.Debugging.Client/AssemblyLine.cs,
	  Mono.Debugging.Client/DebuggerSession.cs: Added support for
	  disassembling files.
	* Mono.Debugging.Client/ObjectValue.cs,
	  Mono.Debugging.Client/ObjectValueKind.cs,
	  Mono.Debugging.Backend/IObjectValueSource.cs: Implemented support
	  for changing the value of an ObjectValue. Improved error reporting.

2008-07-01  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/BreakpointStore.cs,
	  Mono.Debugging.Client/DebuggerSession.cs,
	  Mono.Debugging.Client/Breakpoint.cs: Add support for "invalid"
	  breakpoints (breakpoints placed in locations where there is no
	  source code).

2008-06-26  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/Backtrace.cs: Get only the first stack frame at
	  the begining.
	* Mono.Debugging.Client/ThreadInfo.cs,
	  Mono.Debugging.Client/DebuggerSession.cs: Allow changing the active
	  thread.

2008-06-20  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/DebuggerSession.cs: Improved thread safety.
	  Implemented Detach.

2008-06-20  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/Backtrace.cs,
	  Mono.Debugging.Client/StackFrame.cs,
	  Mono.Debugging.Client/IDebuggerEngine.cs,
	  Mono.Debugging.Client/ObjectPath.cs,
	  Mono.Debugging.Client/ThreadInfo.cs,
	  Mono.Debugging.Client/AssemblyLine.cs,
	  Mono.Debugging.Client/DebuggerSession.cs,
	  Mono.Debugging.Client/ProcessInfo.cs,
	  Mono.Debugging.Client/ObjectValue.cs,
	  Mono.Debugging.Client/TargetEventArgs.cs,
	  Mono.Debugging.Client/ObjectValueKind.cs,
	  Mono.Debugging.Client/DebuggerEngine.cs, Mono.Debugging.mdp,
	  Mono.Debugging.Backend/DissassemblyBuffer.cs,
	  Mono.Debugging.Backend/IDebuggerSessionFrontend.cs,
	  Mono.Debugging.Backend/IBacktrace.cs,
	  Mono.Debugging.Backend/IDebuggerSessionFactory.cs, Makefile.am:
	  Added support for attaching processes and disassembling. Improved
	  API. 

2008-06-16  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/Backtrace.cs: Get 1 initial frame when creating
	  the backtrace.
	* Mono.Debugging.Client/DebuggerSession.cs: Some methods don't need to
	  be virtual.
	* Mono.Debugging.Client/StackFrame.cs: Improved frame description.

2008-06-16  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.mdp: Fixed Mono.Addins reference.

2008-05-27  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/DebuggerSession.cs, Mono.Debugging.mdp,
	  Mono.Debugging.Backend/IDebuggerSessionBackend.cs, Makefile.am:
	  Removed IDebuggerSessionBackend interface. Methods must now be
	  implemented using DebuggerSession overridables.

2008-05-15  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.Debugging.Client/Backtrace.cs,
	  Mono.Debugging.Client/StackFrame.cs,
	  Mono.Debugging.Client/ObjectPath.cs,
	  Mono.Debugging.Client/DebuggerSession.cs,
	  Mono.Debugging.Client/ObjectValue.cs,
	  Mono.Debugging.Client/ObjectValueKind.cs, Mono.Debugging.mdp,
	  Mono.Debugging.Backend/IObjectValueSource.cs,
	  Mono.Debugging.Backend/IBacktrace.cs, Makefile.am: Added api for
	  querying variable and field values. Some improvements in
	  ObjectValue. Added new ObjectPath class.

2008-05-06  Lluis Sanchez  <lluis@novell.com>

	* Imported library

